package myai;
/**
 * Garnetのスピード対戦用AI
 * 敵にぶたれてもいいから波動拳うちまくる。波動拳の射程と攻撃力で瞬殺
 * @author Eita Aoki
 */
import java.util.LinkedList;

import enumerate.Action;
import enumerate.State;
import myutil.My;
import myutil.Node;
import myutil.NodeSpeed;
import structs.CharacterData;
import structs.FrameData;
import structs.GameData;
import structs.MotionData;
public class GarnetSpeedAI extends MyAI{


	  public GarnetSpeedAI(GameData arg0, boolean player){
		  super(arg0,player);
		  System.out.println("GarnetSpeedAI");

	  }
	  //使いたいActionの全量
	  void setRootActions(){
		 this.actionGround=My.actionGround;
		  this.actionAir=My.actionAir;

	  }

	  Node getRootNode(FrameData simFrameData){
			return new NodeSpeed(165 * 100000-(System.nanoTime()-start),simFrameData, null, myActionsEnoughEnergy, oppActionsEnoughEnergy, gd, player,
					  cc);
		}
	  @Override
	  void setHittingMyAction(){

		  bestscore=-9999;
		  bestac=null;
		  HittingMyActions.clear();
		  for(Action ac:myacs){
				double hpscore;
				FrameData nonActionFrame=calc.nonActionFrame;
				FrameData actedFrame=calc.getFrame(ac, calc.NONACT);
				CharacterData nonMy=nonActionFrame.getMyCharacter(player);
				CharacterData actedMy=actedFrame.getMyCharacter(player);
				CharacterData nonOpp=nonActionFrame.getOpponentCharacter(player);
				CharacterData actedOpp=actedFrame.getOpponentCharacter(player);
				hpscore=nonOpp.getHp()-actedOpp.getHp();


				MotionData mo=myMotion.elementAt(ac.ordinal());

				if(hpscore>0){
					HittingMyActions.add(ac);
					double turnscore=
							(double)hpscore
							+(mo.attackDownProperty?30.0:0.0)
							-((double)mo.attackStartUp)*0.01
							-((double)mo.cancelAbleFrame)*0.0001;
					if(turnscore>bestscore){bestscore=turnscore;bestac=ac;}
				}
		  }
	  }

	  @Override
	  Action getPrepareAction(){
		  Action tac=null;
		  if(HittingMyActions.size()>0){
			  if(my.state!=State.AIR){
				  if(calc.getHpScore(tac=Action.CROUCH_B)>0||distance<50){//下げり 10
						return(tac);

					}
				  if(calc.getHpScore(tac=Action.STAND_D_DF_FA)>0){//横波動拳 30
						return(tac);

					}
				  if(calc.getHpScore(tac=Action.STAND_D_DF_FB)>0){//上波動拳 30
						return(tac);

					}
				  if(calc.getHpScore(tac=Action.STAND_D_DB_BA)>0){//AIR扱いのハメ準備技 10
						return(tac);
					}
			  }else {
				  if(calc.getHpScore(tac=Action.AIR_UB)>0){//最強コンボ 20
						return(tac);

					}
			  }


			  return this.mctsprocessing(simFrameData, HittingMyActions);
		  }
		  else
		  {
			  LinkedList<Action> moveActs=
					  (distance<300&&!calc.getEnoughEnergyActions(false,Action.STAND_D_DF_FA,Action.STAND_D_DF_FB).isEmpty())?
							  calc.getEnoughEnergyActions(true,
									  Action.FOR_JUMP,
									  Action.FORWARD_WALK,
									  Action.JUMP,
									  Action.BACK_JUMP,
									  Action.BACK_STEP
									  ):
										  calc.getEnoughEnergyActions(true,
												  Action.FORWARD_WALK,
												  Action.FOR_JUMP,
												  Action.JUMP,
												  Action.BACK_JUMP,
												  Action.BACK_STEP
												  );

							  return(calc.getMinMaxIfHadouken(moveActs));
		  }
	  }





}
